//======================================
//
//ܣƣ״̬
//ر״̬     ______
//            ( )off )
//             ~~~~~~
//״̬    (  on O
//             ~~~~~
//======================================
// ֿʼλ 8,4
//
unit myswitch;

interface

uses
  SysUtils, Classes, Controls ,graphics ,windows;

type
  TMySwitch = class(TGraphicControl)
  private
   // FCanvas: TCanvas;
    FTrueText: string;
    FFalseText: string;
    FLIneColor: TColor;
    //FFontColor: TColor;
    FBackColor: TColor;
    //FFont: TFont;
    FOnOff: Boolean;
    Fx,Fx2,Fy:integer;
    FnewHeight: integer;
    Fnewwidth: integer;
    FTextFont: TFont;
    FOnColor: TColor;
    //FFont: TFont;//
    procedure SetFalseText(const Value: string);
//    procedure SetFontColor(const Value: TColor);
    procedure SetLineColor(const Value: TColor);
    procedure SetTrueText(const Value: string);
    procedure SetBackColor(const Value: TColor);
//    procedure SetFont(const Value: TFont);
    procedure SetOnOff(const Value: Boolean);
    procedure CalcXy;
    procedure SetFont(const Value: TFont);overload;
    procedure SetWidth(const Value:integer);overload;
    procedure setHeight(const value:integer);overload;
    procedure SetOnColor(const Value: TColor);
    
  protected
    procedure Paint; override;
    procedure CreateWnd;overload;
    procedure Click; override; 
   // property Canvas: TCanvas read FCanvas;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
   // property FontColor:TColor  read FFontColor write SetFontColor ;
    property LineColor:TColor read FLineColor write SetLineColor;
    property BackColor:TColor read FBackColor write SetBackColor;
    property OnColor:TColor read FOnColor write SetOnColor;
    Property TrueText:string read FTrueText write SetTrueText;
    property FalseText:string read FFalseText write SetFalseText;
    property Font;
   // property TextFont:TFont read FTextFont write SetFont;//Ҫ :TFont; Ӷֱӱ¶ϼFont
   // property Newwidth:integer read FNewwidth write Setwidth;
   // property NewHeight:integer read FNewHeight write SetHeight;
    property OnOff:Boolean read FOnOff write SetOnOff;
    property OnClick;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MyVCL', [TMySwitch]);
end;

{ TMySwitch }
function RGBToColor(R,G,B:integer):TColor;
begin
  result := StrToInt('$00'+IntToHex(B,2)+IntToHex(G,2)+IntToHex(R,2));
end;

procedure TMySwitch.CalcXy;

begin

 // width := newwidth;
 // height := newheight;
  
  fx := 4;
  fx2 := width - canvas.TextWidth(FTrueText) -4;
  self.Caption := inttostr(fx2);
  if assigned(canvas) then
  fy :=  (height - canvas.TextHeight(FTrueText) )   div 2;
end;

procedure TMySwitch.Click;
begin
  inherited;
  SetOnOFF(Not FOnOFF );

end;

constructor TMySwitch.Create(AOwner: TComponent);
begin
  inherited create(AOwner);
  
    FTrueText := 'On';
    FFalseText:= 'Off';
    FLineColor:= RGBToColor(211,217,215);
    //FFontColor:= RGBToColor(130,134,109);
    FOnColor:= RGBToColor(0,255,0);
    FBackColor:= RGBToColor(198,203,207);
   // FFont := TFont.create;
    Font.Charset  := DEFAULT_CHARSET	; //һҪȱʡַ
    Font.Name     := 'MS Sans Serif'; //һҪ壬
    FOnOff := false;
    Width := 40;
    Height := 16;
   // CalcXy();
end;

procedure TMySwitch.CreateWnd;
begin
  inherited;
  calcxy();
end;

destructor TMySwitch.Destroy;
begin
 // FFont.free;
  inherited;
end;

//ص㣬
procedure TMySwitch.Paint;
begin
   inherited;

   
      canvas.Font := self.Font;
      canvas.Brush.Color := FBackColor;
      canvas.Pen.Color := FLineColor;
      canvas.RoundRect(0,0,width,height,height,height);


      if  FOnOff then
      begin
      //֣ұԲȦ
         canvas.Ellipse(width - height,0,width,height);

         Canvas.Brush.Style:=bsSolid;
         canvas.Brush.Color := FOnColor;
         canvas.Pen.Color := FOnColor;
         canvas.RoundRect(2,2,fx2 -2 ,height -2 ,height div 2  ,height div 2 );



          Canvas.Brush.Style:=bsClear;
         Canvas.textout(fx, fy,FTrueText );
      end
      else
      begin

        canvas.Pen.Color := FLineColor;
        canvas.Ellipse(0,0,height,height);

        
        Canvas.Brush.Style:=bsClear;
        Canvas.textout(fx2, fy, FFalseText);

      end;

end;

procedure TMySwitch.SetBackColor(const Value: TColor);
begin
  FBackColor := Value;
end;

procedure TMySwitch.SetFalseText(const Value: string);
begin
  FFalseText := Value;
end;


//setfont,Ӷ»
procedure TMySwitch.SetFont(const Value: TFont);
begin
 // inherited;
  paint();
end;

procedure TMySwitch.setHeight(const value: integer);
begin
  //inherited;
  calcxy();
  paint();
end;

procedure TMySwitch.SetLineColor(const Value: TColor);
begin
  FLineColor := Value;
end;

procedure TMySwitch.SetOnColor(const Value: TColor);
begin
  FOnColor := Value;
end;

procedure TMySwitch.SetOnOff(const Value: Boolean);
begin
  FOnOff := Value;
  calcxy();
  paint();
end;

procedure TMySwitch.SetTrueText(const Value: string);
begin
  FTrueText := Value;
end;

procedure TMySwitch.SetWidth(const Value: integer);
begin
 // inherited;
  calcxy();
  paint();
end;

end.
